PROGRAM Lernmatrix;
  {einfacher assoziativer Speicher nach Steinbuch}

  CONST
    zeilenzahl  = 8;
    spaltenzahl = 20;

  TYPE
    tBit    = 0..1;
    tMatrix = ARRAY[1..zeilenzahl, 1..spaltenzahl] OF tBit;
    tZeile  = string[spaltenzahl];
    tSpalte = string[zeilenzahl];

  VAR
    Matrix : tMatrix;
    Muster : tZeile;

  PROCEDURE lerne (VAR m: tMatrix);
    {Muster und Bedeutung werden assoziiert}
    VAR
      s, z       : integer;
      e1, e2, e3 : tZeile;
      a1, a2, a3 : tSpalte;
    BEGIN
      FOR z := 1 TO zeilenzahl DO
        FOR s := 1 TO spaltenzahl DO m[z, s] := 0;

    e1 :=      '#--#'; e2 :=      '#--#'; e3 :=      '#---';
    e1 := e1 + '#--#'; e2 := e2 + '#-#-'; e3 := e3 + '#---';
    e1 := e1 + '####'; e2 := e2 + '##--'; e3 := e3 + '#---';
    e1 := e1 + '#--#'; e2 := e2 + '#-#-'; e3 := e3 + '#---';
    e1 := e1 + '#--#'; e2 := e2 + '#--#'; e3 := e3 + '####';

    a1 := '01001000'; {dezimal 72, ASCII-Nr. von H}
    a2 := '01001011'; {dezimal 75, ASCII-Nr. von K}
    a3 := '01001100'; {dezimal 76, ASCII-Nr. von L}

    FOR z := 1 TO zeilenzahl DO
      FOR s := 1 TO spaltenzahl DO
        IF ((e1[s] = '#') AND (a1[z] = '1')) OR
           ((e2[s] = '#') AND (a2[z] = '1')) OR
           ((e3[s] = '#') AND (a3[z] = '1')) THEN m[z, s] := 1
  END; {of lerne}

  PROCEDURE lies_ein (VAR buchstabe: tZeile);
    {liest Buchstaben ein, der vom Netz erkannt werden soll}
    VAR
      i     : integer;
      zeile : string[4];
    BEGIN
      writeln('Geben Sie den zu erkennenden Buchstaben in ');
      writeln('5 Zeilen der Gestalt #--# (4 Zeichen) ein!');
      writeln; buchstabe := '';
      FOR i := 1 TO 5 DO BEGIN
        readln(zeile); buchstabe := buchstabe + zeile
      END {of for}
    END; {of lies_ein}

  PROCEDURE assoziiere (buchstabe: tZeile; m: tMatrix);
    {zum eingegebenen Buchstaben wird mittels der Lernmatrix
     dessen Bedeutung (ASCII-Nummer) assoziiert und ausgegeben}
    VAR
      summe                   : ARRAY[1..zeilenzahl] OF integer;
      schwelle, z, s, asciiNr : integer;
    BEGIN
      schwelle := 0;
      FOR z := 1 TO zeilenzahl DO BEGIN
        summe[z] := 0;
        FOR s := 1 TO spaltenzahl DO
        IF buchstabe[s] = '#' THEN inc (summe[z], m[z, s]);
        IF schwelle < summe[z] THEN schwelle := summe[z]
    END; {of for}

    writeln; write('Summenvektor: ');
    FOR z := 1 TO zeilenzahl DO write(summe[z], ' '); writeln;

    asciiNr := 0;
    FOR z := 1 TO zeilenzahl DO
      IF   summe[z] < schwelle
      THEN asciiNr := 2 * asciiNr
      ELSE asciiNr := 2 * asciiNr + 1;

    writeln; writeln('Die Bedeutung ist ', chr(asciiNr))
  END; {of assoziiere}


BEGIN {Hauptprogramm}
  lerne(Matrix);
  lies_ein(Muster);
  assoziiere(Muster, Matrix);
  readln
END.
        
